<template>
	<ValidationProvider
		v-slot="{ errors, ariaMsg, ariaInput }"
		:rules="rules"
		:immediate="false"
		onkeydown="return event.key != 'Enter';"
	>
		<div class="grid-cols-1 lg:gap-10 gap-6 md:grid-cols-2 grid w-full mt-8 md:mt-6 lg:mt-8" role="radiogroup" aria-labelledby="radio-group">
			<label
				v-for="(content, i) in contents"
				:key="i"
				v-bind="ariaInput"
				:for="'address_id' + i"
				:aria-checked="content.id == selectedValue.id"
				:aria-label="`${content.firstName + ' ' + content.lastName} ${content.streetName + ' '}${
					' ' + content.city + ',' + content.state + ' ' + content.postalCode
				} ${content.phoneNumber}`"
				:class="content.id == selectedValue.id ? 'border-black' : 'border-grey-20'"
				class="cursor-pointer border rounded md:rounded-md lg:rounded w-auto md:w-rSlide-md lg:w-72 px-4 py-6 md:px-6 md:py-6 focus:outline-nonebreak-all"
				@click="addressSelect(content)"
				@keypress.enter="addressSelect(content)"
			>
				<input name="address_list" role="radio" :aria-checked="content.id == selectedValue.id" :tabindex="content.id == selectedValue.id || (i == 0 && !selectedValue.id) ? 0 : -1" type="radio" :id="'address_id' + i" class="absolute opacity-0"/>
				<p aria-hidden="true" class="font-primary-font-bold text-base leading-6">
					{{ content.firstName + ' ' + content.lastName }}
				</p>
				<p aria-hidden="true" class="font-primary-font-regular text-base leading-6 mt-2">
					{{ (content.streetAddress1 || content.streetName) + ' ' }}
				</p>
				<p aria-hidden="true" class="font-primary-font-regular text-base leading-6">
					{{ ' ' + content.city + ',' + (content.state || '') + ' ' + content.postalCode }}
				</p>
				<p aria-hidden="true" class="font-primary-font-regular text-base leading-6">
					{{ content.phone | phone }}
				</p>
			</label>
		</div>
		<p v-show="errors" class="text-error-20 text-sm" v-bind="ariaMsg">
			{{ errors[0] }}
		</p>
	</ValidationProvider>
</template>
<script>
import { ValidationProvider } from 'vee-validate';
export default {
	name: 'MkAddressTile',
	components: {
		ValidationProvider,
	},
	props: {
		contents: {
			type: [Array, Object],
			default: () => [],
		},
		selectedAddress: {
			type: Object,
			default: () => {},
		},
		rules: {
			type: String,
			default: '',
		},
		recentShipping: {
			type: String,
			default: '',
		},
	},
	data() {
		return {
			selected: false,
		};
	},
	computed: {
		selectedValue() {
			return this.selectedAddress;
		},
	},
	watch: {
		recentShipping() {
			this.setRecentShipping();
		},
	},
	mounted() {
		this.setRecentShipping();
	},
	methods: {
		addressSelect(item) {
			this.$emit('selected', item);
		},
		setRecentShipping() {
			if (this.recentShipping !== '' && !this.selectedAddress.id) {
				this.selectedValue.id = this.recentShipping;
				const $recentAddress = this.contents.filter(($obj) => {
					return $obj.id === this.recentShipping;
				});
				if ($recentAddress && $recentAddress.length) {
					this.addressSelect($recentAddress[0]);
				}
			} else if(this.contents.length > 0){
				let $content = this.contents[0]
				this.selectedAddress = $content
				this.addressSelect($content[0]);
			}
		},
	},
};
</script>
